diff a/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64int.java b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64int.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64int extends PrimitiveStates {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void consume_int(int v0, int v1) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void read(Primitive64int st) {
+        int[] values = st.arr;
+        for (int i = 0; i < values.length; i+=2) {
+            consume_int(values[i], values[i+1]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64long.java b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/read/Primitive64long.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.read;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64long extends PrimitiveStates {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void consume_long(long v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p64long_read(Primitive64long st) {
+        long[] values = st.arr;
+        for (int i = 0; i < values.length; i++) {
+            consume_long(values[i]);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/array/set/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Inline128int.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_set(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q128int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q128int(i);
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q128int getRef(int i) {
+        return new Q128int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q128int getVal(int i) {
+        return new Q128int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_set(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set(Val_as_Val st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q128int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Inline32int.java b/test/micro/org/openjdk/bench/valhalla/array/set/Inline32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Inline32int.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ32int;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline32int extends StatesQ32int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_set(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q32int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q32int(i);
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q32int getRef(int i) {
+        return new Q32int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q32int getVal(int i) {
+        return new Q32int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_set(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set(Val_as_Val st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q32int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/array/set/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Inline64byte.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64byte;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64byte extends StatesQ64byte {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_set(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q64byte(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q64byte(i);
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64byte getRef(int i) {
+        return new Q64byte(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64byte getVal(int i) {
+        return new Q64byte(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_set(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set(Val_as_Val st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64byte[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/array/set/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Inline64int.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ64int;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64int extends StatesQ64int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_as_Val_set(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q64int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = new Q64int(i);
+        }
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64int getRef(int i) {
+        return new Q64int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q64int getVal(int i) {
+        return new Q64int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_as_Val_set(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_as_Val_set(Val_as_Val st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_as_Ref_set(Ref_as_Ref st) {
+        Q64int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = getVal(i);
+        }
+    }
+
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Primitive32.java b/test/micro/org/openjdk/bench/valhalla/array/set/Primitive32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Primitive32.java
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive32 extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void set(Primitive32int st) {
+        int[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = i;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/set/Primitive64.java b/test/micro/org/openjdk/bench/valhalla/array/set/Primitive64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/set/Primitive64.java
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.set;
+
+import org.openjdk.bench.valhalla.array.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64 extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void set0(Primitive64long st) {
+        long[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i] = i;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void set1(Primitive64long st) {
+        int len = st.arr.length;
+        for (int i = 0; i < len; i++) {
+            st.arr[i] = i;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/IdentityOpt.java b/test/micro/org/openjdk/bench/valhalla/array/sum/IdentityOpt.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/IdentityOpt.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesROpt;
+import org.openjdk.bench.valhalla.types.Int32;
+import org.openjdk.bench.valhalla.types.Opt;
+import org.openjdk.bench.valhalla.types.ROpt;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class IdentityOpt extends StatesROpt {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_fields(Ref_as_Ref st) {
+        int s = 0;
+        ROpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].value.intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_sum(Ref_as_Ref st) {
+        int s = 0;
+        ROpt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(Int_as_Int st) {
+        int s = 0;
+        Opt<Int32>[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].get().intValue();
+        }
+        return s;
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/sum/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/sum/Inline128int.java
@@ -0,0 +1,141 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.sum;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.ByInt;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_fields(Val_as_Val st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0.v0;
+            s += arr[i].v0.v1.v0;
+            s += arr[i].v1.v0.v0;
+            s += arr[i].v1.v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_fields(Val_as_Ref st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0.v0;
+            s += arr[i].v0.v1.v0;
+            s += arr[i].v1.v0.v0;
+            s += arr[i].v1.v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_fields(Ref_as_Ref st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].v0.v0.v0;
+            s += arr[i].v0.v1.v0;
+            s += arr[i].v1.v0.v0;
+            s += arr[i].v1.v1.v0;
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Val_sum(Val_as_Val st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Ref_sum(Val_as_Ref st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Ref_sum(Ref_as_Ref st) {
+        int s = 0;
+        Q128int[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Val_as_Int_sum(Val_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Ref_as_Int_sum(Ref_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public int Int_as_Int_sum(By_as_By st) {
+        int s = 0;
+        ByInt[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            s += arr[i].intSum();
+        }
+        return s;
+    }
+
+}
